local AceGUI = LibStub("AceGUI-3.0")
local addonName, BGS_FrameInfoTable = ...
local _frameName = "AccKillsFrame"
local _detail = "Account Kills"
local _icon = [[Interface\ICONS\warrior_skullbanner]]
local _info = "Honorable kills across your account (250k limit)"
local _options = {}


local scrollcontainer = AceGUI:Create("SimpleGroup") -- "InlineGroup" is also good
scrollcontainer:SetFullWidth(true)
scrollcontainer:SetWidth(185)
scrollcontainer:SetFullHeight(true) -- probably?
scrollcontainer:SetHeight(170)
scrollcontainer:SetLayout("Fill") -- important!

table.insert(_options, scrollcontainer)

local scroll = AceGUI:Create("ScrollFrame")
scroll:SetLayout("Flow") -- probably?
scrollcontainer:AddChild(scroll)

local frameDetail = AceGUI:Create("SimpleGroup")
frameDetail:SetFullWidth(true)
frameDetail:SetHeight(35)
frameDetail:SetLayout("Fill")
frameDetail.bg = frameDetail.frame:CreateTexture("frameDetail_Tex")
frameDetail.bg:SetTexture("Interface\\LFGFRAME\\UI-LFG-SEPARATOR")
frameDetail.bg:SetHeight(frameDetail.frame:GetHeight()/2)
frameDetail.bg:SetTexCoord(0, 168/256, 0, 34/128)
frameDetail.bg:SetPoint("bottom", 0, -2)
frameDetail.text = frameDetail.frame:CreateFontString(nil, nil, "GameFontHighlightSmall")
frameDetail.text:SetHeight(frameDetail.frame:GetHeight())
frameDetail.text:SetText(_info)
frameDetail.text:SetPoint("topleft", 0, 0)
frameDetail.text:SetPoint("topright", 0, 0)
scroll:AddChild(frameDetail)

table.insert(BGS_FrameInfoTable, { name = _frameName		--4
	, detail = _detail
	, icon = _icon
	, info = _info
	, options = _options
	}
	)

	
local function UpdateAccKillsInfo()
	local KillsFrame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	KillsFrame.text:SetText(BGS_FrameInfoTable:GetAccHKills())
end	
	
local function eventHandle(event)
	if not (BGS_FrameInfoTable:GetFrameByName(_frameName)) then
		return
	end
	
	if event == "PLAYER_PVP_KILLS_CHANGED" or event == "PLAYER_LOGIN" then
		UpdateAccKillsInfo()
	return
	end
	
	if event == "ADDON_LOADED" then
		if addon ~= addonName then return end
		self:UnregisterEvent("ADDON_LOADED")
		
		
		return
	end
end

local _eventsFrame = CreateFrame("FRAME", "BGS_".._frameName.."Events"); 
_eventsFrame:RegisterEvent("PLAYER_LOGIN");
_eventsFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
_eventsFrame:RegisterEvent("ADDON_LOADED");
_eventsFrame:SetScript("OnEvent", function(self, event, ...) eventHandle(event) end)