local AceGUI = LibStub("AceGUI-3.0")
local addonName, BGS_FrameInfoTable = ...
local _frameName = "AchFrame"
local _detail = "Achievement"
local _icon = [[Interface\ICONS\INV_Misc_QuestionMark]]
local _info = "Amount of kills until next account wide achievment"
local _options = {}

local scrollcontainer = AceGUI:Create("SimpleGroup") -- "InlineGroup" is also good
scrollcontainer:SetFullWidth(true)
scrollcontainer:SetWidth(185)
scrollcontainer:SetFullHeight(true) -- probably?
scrollcontainer:SetHeight(170)
scrollcontainer:SetLayout("Fill") -- important!

table.insert(_options, scrollcontainer)

	local scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow") -- probably?
	scrollcontainer:AddChild(scroll)

	local frameDetail = AceGUI:Create("SimpleGroup")
	frameDetail:SetFullWidth(true)
	frameDetail:SetHeight(35)
	frameDetail:SetLayout("Fill")
	frameDetail.bg = frameDetail.frame:CreateTexture("frameDetail_Tex")
	frameDetail.bg:SetTexture("Interface\\LFGFRAME\\UI-LFG-SEPARATOR")
	frameDetail.bg:SetHeight(frameDetail.frame:GetHeight()/2)
	frameDetail.bg:SetTexCoord(0, 168/256, 0, 34/128)
	frameDetail.bg:SetPoint("bottom", 0, -2)
	frameDetail.text = frameDetail.frame:CreateFontString(nil, nil, "GameFontHighlightSmall")
	frameDetail.text:SetHeight(frameDetail.frame:GetHeight())
	frameDetail.text:SetText(_info)
	frameDetail.text:SetPoint("topleft", 0, 0)
	frameDetail.text:SetPoint("topright", 0, 0)
	scroll:AddChild(frameDetail)


table.insert(BGS_FrameInfoTable, { name = _frameName		--5
	, detail = _detail
	, icon = _icon
	, info = _info
	, options = _options
	}
	)

local function UpdateAchInfo()
	local AchFrame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	
	local HKills = BGS_FrameInfoTable:GetAccHKills()
	local AchRankPath = [[]]
	local KillsLeft = 0
	if HKills < 1 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_01]]
		KillsLeft = 1 - HKills
	elseif 1 <= HKills and HKills < 100 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_02]]
		KillsLeft = 100 - HKills
	elseif 100 <= HKills and HKills < 500 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_03]]
		KillsLeft = 500 - HKills
	elseif 500 <= HKills and HKills < 1000 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_04]]
		KillsLeft = 1000 - HKills
	elseif 1000 <= HKills and HKills < 5000 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_06]]
		KillsLeft = 5000 - HKills
	elseif 5000 <= HKills and HKills < 10000 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_09]]
		KillsLeft = 10000 - HKills
	elseif 10000 <= HKills and HKills < 25000 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_11]]
		KillsLeft = 25000 - HKills
	elseif 25000 <= HKills and HKills < 50000 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_14]]
		KillsLeft = 50000 - HKills
	elseif 50000 <= HKills and HKills < 100000 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_15]]
		KillsLeft = 100000 - HKills
	elseif 100000 <= HKills and HKills < 250000 then
		AchRankPath = [[Interface\ICONS\Achievement_PVP_P_16]]
		KillsLeft = 250000 - HKills
	elseif 250000 <= HKills then
		AchRankPath = [[Interface\ICONS\Achievement_BG_KillFlagCarriers_grabFlag_CapIt]]
		KillsLeft = "Max Rank"
	end
	AchFrame.icon:SetTexture(AchRankPath)

   
   AchFrame.text:SetText(KillsLeft)
   
end
	
local function eventHandle(event)
	if not (BGS_FrameInfoTable:GetFrameByName(_frameName)) then
		return
	end
	
	if event == "PLAYER_PVP_KILLS_CHANGED" or event == "PLAYER_LOGIN" then
		UpdateAchInfo()
	return
	end
	
	if event == "ADDON_LOADED" then
		if addon ~= addonName then return end
		self:UnregisterEvent("ADDON_LOADED")
		return
	end
end

local _eventsFrame = CreateFrame("FRAME", "BGS_".._frameName.."Events");
_eventsFrame:RegisterEvent("PLAYER_LOGIN");
_eventsFrame:RegisterEvent("ADDON_LOADED");
_eventsFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
_eventsFrame:SetScript("OnEvent", function(self, event, ...) eventHandle(event) end)