local AceGUI = LibStub("AceGUI-3.0")
local addonName, BGS_FrameInfoTable = ...
local _frameName = "ConquestFrame"
local _detail = "Conquest Points"
local _icon = [[Interface\ICONS\INV_Misc_QuestionMark]]
local _info = "Amount of conquest points on this character"
local _options = {}

local scrollcontainer = AceGUI:Create("SimpleGroup") -- "InlineGroup" is also good
scrollcontainer:SetFullWidth(true)
scrollcontainer:SetWidth(185)
scrollcontainer:SetFullHeight(true) -- probably?
scrollcontainer:SetHeight(170)
scrollcontainer:SetLayout("Fill") -- important!

table.insert(_options, scrollcontainer)

	local scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow") -- probably?
	scrollcontainer:AddChild(scroll)

	local frameDetail = AceGUI:Create("SimpleGroup")
	frameDetail:SetFullWidth(true)
	frameDetail:SetHeight(35)
	frameDetail:SetLayout("Fill")
	frameDetail.bg = frameDetail.frame:CreateTexture("frameDetail_Tex")
	frameDetail.bg:SetTexture("Interface\\LFGFRAME\\UI-LFG-SEPARATOR")
	frameDetail.bg:SetHeight(frameDetail.frame:GetHeight()/2)
	frameDetail.bg:SetTexCoord(0, 168/256, 0, 34/128)
	frameDetail.bg:SetPoint("bottom", 0, -2)
	frameDetail.text = frameDetail.frame:CreateFontString(nil, nil, "GameFontHighlightSmall")
	frameDetail.text:SetHeight(frameDetail.frame:GetHeight())
	frameDetail.text:SetText(_info)
	frameDetail.text:SetPoint("topleft", 0, 0)
	frameDetail.text:SetPoint("topright", 0, 0)
	scroll:AddChild(frameDetail)

table.insert(BGS_FrameInfoTable, { name = _frameName		--2
	, detail = _detail
	, icon = _icon
	, info = _info
	, options = _options
	}
	)
	
local function UpdateConquestInfo()
	local ConquestFrame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	ConquestFrame.text:SetText(BGS_FrameInfoTable:GetConquest())
end

local function ConquestIcon()
	local EnglishFaction, localizedFaction = UnitFactionGroup("player")
	local bg = nill
	local ConquestFrame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	if EnglishFaction == "Horde" then
        bg = [[Interface\ICONS\PVPCurrency-Conquest-Horde]]
	else
        bg = [[Interface\ICONS\PVPCurrency-Conquest-Alliance]]
	end
	ConquestFrame.icon:SetTexture(bg)
	
end

local function eventHandle(self, event, addon)
	if not (BGS_FrameInfoTable:GetFrameByName(_frameName)) then
		return
	end
	
	if event == "CURRENCY_DISPLAY_UPDATE" or event == "PLAYER_LOGIN" then
		UpdateConquestInfo()
	return
	end
	if event == "ADDON_LOADED" then
		if addon ~= addonName then return end
		self:UnregisterEvent("ADDON_LOADED")
		ConquestIcon()
		return
	end
end

local _eventsFrame = CreateFrame("FRAME", "BGS_".._frameName.."Events");
_eventsFrame:RegisterEvent("PLAYER_LOGIN");
_eventsFrame:RegisterEvent("ADDON_LOADED");
_eventsFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
_eventsFrame:SetScript("OnEvent", function(self, event, ...) eventHandle(self, event, ...) end)