local AceGUI = LibStub("AceGUI-3.0")
local addonName, BGS_FrameInfoTable = ...
local _frameName = "HolidayFrame"
local _detail = "Call to Arms"
local _icon = [[Interface\ICONS\INV_Misc_QuestionMark]]
local _info = "The current Call to Arms"
local updateTimer = 0
local _holidayInfoList = {{full = "Warsong Gulch", short = "WSG", shortPers = "WSG", icon = "Interface\\ICONS\\INV_Misc_Rune_07"}
						,{full = "Arathi Basin", short = "AB", shortPers = "AB", icon = "Interface\\ICONS\\INV_Jewelry_Amulet_07"}
						,{full = "Alterac Valley", short = "AV", shortPers = "AV", icon = "Interface\\ICONS\\INV_Jewelry_Necklace_21"}
						,{full = "Eye of the Storm", short = "EotS", shortPers = "EotS", icon = "Interface\\ICONS\\Spell_Nature_EyeOfTheStorm"}
						,{full = "Strand of the Ancients", short = "SotA", shortPers = "SotA", icon = "Interface\\ICONS\\Achievement_BG_winSOA"}
						,{full = "Isle of Conquest", short = "IoC", shortPers = "IoC", icon = "Interface\\ICONS\\Achievement_BG_winWSG"}
						,{full = "The Battle for Gilneas", short = "BfG", shortPers = "BfG", icon = "Interface\\ICONS\\Achievement_Battleground_BattleForGilneas"}
						,{full = "Twin Peaks", short = "Twin Peaks", shortPers = "Twin Peaks", icon = "Interface\\ICONS\\spell_nature_earthshock"}
						,{full = "Silvershard Mines", short = "Silv. Mines", shortPers = "Silv. Mines", icon = "Interface\\ICONS\\INV_Crate_07"}
						,{full = "Temple of Kotmogu", short = "Temp. of K.", shortPers = "Temp. of K.", icon = "Interface\\ICONS\\Achievement_Battleground_TempleOfKotmogu_02"}
						,{full = "Deepwind Gorge", short = "Deepw. G.", shortPers = "Deepw. G.", icon = "Interface\\ICONS\\achievement_zone_valleyoffourwinds"}
						}
local useShortName = true
local _options = {}
local __
local _OptionTable = {}

local function UpdateHolidayInfo()
	local holidayFrame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	local IconPath = [[InterFace\ICONS\Spell_Shadow_Twilight]];
	local ShortStr = "" .. BGS_FrameInfoTable:GetBGHoliday()
	for k, v in ipairs(_holidayInfoList) do
		if (v.full == ShortStr) then
			holidayFrame.text:SetWidth(0)
			if (useShortName) then
				ShortStr = v.shortPers
			end
			IconPath = v.icon;
			holidayFrame.text:SetText(ShortStr)
			holidayFrame.icon:SetTexture(IconPath)
			
			local textLength = holidayFrame.text:GetWidth()
			if (textLength > (holidayFrame:GetWidth()-30)) then
				holidayFrame.text:SetWidth(holidayFrame:GetWidth()-36)
			end
			
			return
		end
	end
	
	ShortStr = "Unknown BG"
	holidayFrame.text:SetText(ShortStr)
	holidayFrame.icon:SetTexture(IconPath)
end
local scrollcontainer = AceGUI:Create("SimpleGroup") -- "InlineGroup" is also good
--scrollcontainer.frame:SetParent(optionFrame)
scrollcontainer:SetFullWidth(true)
scrollcontainer:SetWidth(185)
scrollcontainer:SetFullHeight(true) -- probably?
scrollcontainer:SetHeight(170)
scrollcontainer:SetLayout("Fill") -- important!

table.insert(_options, scrollcontainer)


	local scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow") -- probably?
	scrollcontainer:AddChild(scroll)

	local frameDetail = AceGUI:Create("SimpleGroup")
	frameDetail:SetFullWidth(true)
	frameDetail:SetHeight(35)
	frameDetail:SetLayout("Fill")
	frameDetail.bg = frameDetail.frame:CreateTexture("frameDetail_Tex")
	frameDetail.bg:SetTexture("Interface\\LFGFRAME\\UI-LFG-SEPARATOR")
	frameDetail.bg:SetHeight(frameDetail.frame:GetHeight()/2)
	frameDetail.bg:SetTexCoord(0, 168/256, 0, 34/128)
	frameDetail.bg:SetPoint("bottom", 0, -2)
	frameDetail.text = frameDetail.frame:CreateFontString(nil, nil, "GameFontHighlightSmall")
	frameDetail.text:SetHeight(frameDetail.frame:GetHeight())
	frameDetail.text:SetText(_info)
	frameDetail.text:SetPoint("topleft", 0, 0)
	frameDetail.text:SetPoint("topright", 0, 0)
	scroll:AddChild(frameDetail)

	local cbx_abbr = AceGUI:Create("CheckBox")
--cbx_abbr.frame:SetParent(optionFrame)
	cbx_abbr:SetLabel("Use abbreviations")
	cbx_abbr:SetValue(true)
	cbx_abbr:SetPoint("topleft", optionFrame, "topleft", 10, 0)
	cbx_abbr:SetCallback("OnValueChanged", function(__,__, value)
		useShortName = value
		UpdateHolidayInfo()
	end)

	_OptionTable.cbx_abbr = cbx_abbr

	scroll:AddChild(cbx_abbr)
	
	for key, name in ipairs(_holidayInfoList) do
		local txt_Short = AceGUI:Create("EditBox")
		--txt_Short.frame:SetParent(optionFrame)
		txt_Short:SetLabel(name.full)
		txt_Short:SetText(name.short)
		txt_Short:SetWidth(120)
		--txt_Short:SetPoint("topleft", scroll, "topleft", 10, 0)
		txt_Short:SetCallback("OnEnterPressed", function(__,__, value)
			for k, v in ipairs(_holidayInfoList) do
				if (v.full == name.full) then
					v.shortPers = value
				end
			end
			UpdateHolidayInfo()
		end)
	
		name.editBox = txt_Short
		scroll:AddChild(txt_Short)
	
		local btn_Reset = AceGUI:Create("Button")
		--btn_Reset.frame:SetParent(optionFrame)
		btn_Reset:SetText("R")
		btn_Reset.text:SetPoint("TOPLEFT", 5, -1)
		btn_Reset.text:SetPoint("BOTTOMRIGHT", -5, 1)
		btn_Reset:SetWidth(25)
		btn_Reset:SetPoint("bottomleft", txt_Short.frame, "bottomright", 0, 0)
		btn_Reset:SetCallback("OnClick", function() 
			for k, v in ipairs(_holidayInfoList) do
				if (v.full == name.full) then
					v.shortPers = v.short
					txt_Short:SetText(name.short)
				end
			end
			UpdateHolidayInfo()
		end)
	
		scroll:AddChild(btn_Reset)
	end


table.insert(BGS_FrameInfoTable, { name = _frameName		--6
	, detail = _detail
	, icon = _icon
	, info = _info
	, options = _options
	}
	)
	

local function _HolidayFrameScript()
	local holidayFrame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	holidayFrame:SetScript("OnUpdate", function(self,elapsed) 
	updateTimer = updateTimer + elapsed
	if updateTimer >= 60*30 then
		UpdateHolidayInfo()
		updateTimer = 0
	end
	end)
end
	
local function eventHandle(self, event, addon)
	if not (BGS_FrameInfoTable:GetFrameByName(_frameName)) then
		return
	end
	
	if event == "PLAYER_PVP_KILLS_CHANGED" or event == "PLAYER_LOGIN" then
		--createOptions()
		UpdateHolidayInfo()
	return
	end
	if event == "ADDON_LOADED" then
		if addon ~= addonName then return end
		self:UnregisterEvent("ADDON_LOADED")
		_HolidayFrameScript()
		
		local infoList = BGS_FrameInfoTable:GetInfoList(_frameName)
		
		if not (infoList)then
			return
		end
		
		if infoList.useShort ~= nil then
			useShortName = infoList.useShort
			_OptionTable.cbx_abbr:SetValue(useShortName)
		end
		
		if infoList.holidayInfoList ~= nil then
			for k, saved in ipairs(infoList.holidayInfoList) do
				for k, base in ipairs(_holidayInfoList) do
					if base.full == saved.full then
						base.shortPers = saved.shortPers
						base.editBox:SetText(base.shortPers)
					end
				end
			end
		end
		
		
		
		return
	end
	
	if event == "PLAYER_LOGOUT" then
		local frame = BGS_FrameInfoTable:GetFrameByName(_frameName)
		
		local smallArray = {}
		
		for k, v in ipairs (_holidayInfoList) do
			local short = {}
			short.full = v.full
			short.shortPers = v.shortPers
			table.insert(smallArray, short)
		
		end
		
		table.insert(BGstats_ExtraFrameDataList, {frame = _frameName, useShort = useShortName, holidayInfoList = smallArray})
	end
end

local _eventsFrame = CreateFrame("FRAME", "BGS_".._frameName.."Events");
_eventsFrame:RegisterEvent("PLAYER_LOGIN");
_eventsFrame:RegisterEvent("ADDON_LOADED");
_eventsFrame:RegisterEvent("PLAYER_LOGOUT");
_eventsFrame:SetScript("OnEvent", function(self, event, ...) eventHandle(self, event, ...) end)