local AceGUI = LibStub("AceGUI-3.0")
local addonName, BGS_FrameInfoTable = ...
local _frameName = "HonorFrame"
local _detail = "Honor Points"
local _icon = [[Interface\ICONS\INV_Misc_QuestionMark]]
local _info = "Amount of honor points on this character"
local _options = {}

local scrollcontainer = AceGUI:Create("SimpleGroup") -- "InlineGroup" is also good
scrollcontainer:SetFullWidth(true)
scrollcontainer:SetWidth(185)
scrollcontainer:SetFullHeight(true) -- probably?
scrollcontainer:SetHeight(170)
scrollcontainer:SetLayout("Fill") -- important!

table.insert(_options, scrollcontainer)


	local scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow") -- probably?
	scrollcontainer:AddChild(scroll)

	local frameDetail = AceGUI:Create("SimpleGroup")
	frameDetail:SetFullWidth(true)
	frameDetail:SetHeight(35)
	frameDetail:SetLayout("Fill")
	frameDetail.bg = frameDetail.frame:CreateTexture("frameDetail_Tex")
	frameDetail.bg:SetTexture("Interface\\LFGFRAME\\UI-LFG-SEPARATOR")
	frameDetail.bg:SetHeight(frameDetail.frame:GetHeight()/2)
	frameDetail.bg:SetTexCoord(0, 168/256, 0, 34/128)
	frameDetail.bg:SetPoint("bottom", 0, -2)
	frameDetail.text = frameDetail.frame:CreateFontString(nil, nil, "GameFontHighlightSmall")
	frameDetail.text:SetHeight(frameDetail.frame:GetHeight())
	frameDetail.text:SetText(_info)
	frameDetail.text:SetPoint("topleft", 0, 0)
	frameDetail.text:SetPoint("topright", 0, 0)
	scroll:AddChild(frameDetail)


table.insert(BGS_FrameInfoTable, { name = _frameName		--1
	, detail = _detail
	, icon = _icon
	, info = _info
	, options = _options
	}
	)
		
local function UpdateHonorInfo()
	local frame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	frame.text:SetText(BGS_FrameInfoTable:GetHonor())
end

local function HonorIcon()
	local frame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	local EnglishFaction, localizedFaction = UnitFactionGroup("player")
	local bg = nill
	if EnglishFaction == "Horde" then
		bg = [[Interface\ICONS\PVPCurrency-Honor-Horde]]
	else
        bg = [[Interface\ICONS\PVPCurrency-Honor-Alliance]]
	end
	frame.icon:SetTexture(bg)
end

local function eventHandle(self, event, addon)
	if not (BGS_FrameInfoTable:GetFrameByName(_frameName)) then
		return
	end
	
	if event == "CURRENCY_DISPLAY_UPDATE" or event == "PLAYER_LOGIN" then
		UpdateHonorInfo()
	return
	end
	if event == "ADDON_LOADED" then
		if addon ~= addonName then return end
		self:UnregisterEvent("ADDON_LOADED")
		
		HonorIcon()
		return
	end
end

local _eventsFrame = CreateFrame("FRAME", "BGS_".._frameName.."Events");
_eventsFrame:RegisterEvent("PLAYER_LOGIN");
_eventsFrame:RegisterEvent("CURRENCY_DISPLAY_UPDATE");
_eventsFrame:RegisterEvent("ADDON_LOADED");
_eventsFrame:SetScript("OnEvent", function(self, event, ...) eventHandle(self, event, ...) end)