local AceGUI = LibStub("AceGUI-3.0")
local addonName, BGS_FrameInfoTable = ...
local _frameName = "ScoreFrame"
local _detail = "Battleground Stats"
local _icon = [[Interface\ICONS\INV_Misc_QuestionMark]]
local _info = "Kills, killing blows and deaths in the current battleground"
local _options = {}

local scrollcontainer = AceGUI:Create("SimpleGroup") -- "InlineGroup" is also good
scrollcontainer:SetFullWidth(true)
scrollcontainer:SetWidth(185)
scrollcontainer:SetFullHeight(true) -- probably?
scrollcontainer:SetHeight(170)
scrollcontainer:SetLayout("Fill") -- important!

table.insert(_options, scrollcontainer)

	local scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow") -- probably?
	scrollcontainer:AddChild(scroll)

	local frameDetail = AceGUI:Create("SimpleGroup")
	frameDetail:SetFullWidth(true)
	frameDetail:SetHeight(35)
	frameDetail:SetLayout("Fill")
	frameDetail.bg = frameDetail.frame:CreateTexture("frameDetail_Tex")
	frameDetail.bg:SetTexture("Interface\\LFGFRAME\\UI-LFG-SEPARATOR")
	frameDetail.bg:SetHeight(frameDetail.frame:GetHeight()/2)
	frameDetail.bg:SetTexCoord(0, 168/256, 0, 34/128)
	frameDetail.bg:SetPoint("bottom", 0, -2)
	frameDetail.text = frameDetail.frame:CreateFontString(nil, nil, "GameFontHighlightSmall")
	frameDetail.text:SetHeight(frameDetail.frame:GetHeight())
	frameDetail.text:SetText(_info)
	frameDetail.text:SetPoint("topleft", 0, 0)
	frameDetail.text:SetPoint("topright", 0, 0)
	scroll:AddChild(frameDetail)


table.insert(BGS_FrameInfoTable, { name = _frameName		--7
	, detail = _detail
	, icon = _icon
	, info = _info
	, options = _options
	}
	)

local function BGScoreIcon()
	local ScoreFrame = BGS_FrameInfoTable:GetFrameByName("ScoreFrame")
   local EnglishFaction, localizedFaction = UnitFactionGroup("player")
   local bg = nill
   if EnglishFaction == "Horde" then
		bg = [[Interface\ICONS\Achievement_PVP_H_H]]
   else
		bg = [[Interface\ICONS\Achievement_PVP_A_A]]
   end
	ScoreFrame.icon:SetTexture(bg)
end
	
local function UpdateBGScoreInfo()
	local isInstance, instanceType = IsInInstance()
	
	if instanceType == "pvp" then
		local ScoreFrame = BGS_FrameInfoTable:GetFrameByName(_frameName)
		RequestBattlefieldScoreData()
		for i = 1, GetNumBattlefieldScores() do
			local name, killingBlows, honorableKills, deaths, honorGained, faction, race, class, classToken, damageDone, healingDone = GetBattlefieldScore(i)
			if name == GetUnitName("player", false) then
				ScoreFrame.text:SetText("" .. honorableKills .. "(" .. killingBlows .. ") / " .. deaths)
				return --no need to count more
			end
		end
	end
end
	
local function eventHandle(self, event, addon)
	if not (BGS_FrameInfoTable:GetFrameByName(_frameName)) then
		return
	end
	UpdateBGScoreInfo()
	-- if event == "CURRENCY_DISPLAY_UPDATE" or event == "PLAYER_LOGIN" then
		
	-- return
	-- end
	if event == "ADDON_LOADED" then
		if addon ~= addonName then return end
		self:UnregisterEvent("ADDON_LOADED")
		
		BGScoreIcon()
		local ScoreFrame = BGS_FrameInfoTable:GetFrameByName(_frameName)
		ScoreFrame.text:SetText("" .. 0 .. "(" .. 0 .. ") / " .. 0)
		return
	end
end

local _eventsFrame = CreateFrame("FRAME", "BGS_".._frameName.."Events");
_eventsFrame:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND");
_eventsFrame:RegisterEvent("PLAYER_ENTERING_WORLD");
_eventsFrame:RegisterEvent("PLAYER_PVP_KILLS_CHANGED");
_eventsFrame:RegisterEvent("UPDATE_BATTLEFIELD_SCORE");
_eventsFrame:RegisterEvent("PLAYER_DEAD");
_eventsFrame:RegisterEvent("ADDON_LOADED");
_eventsFrame:SetScript("OnEvent", function(self, event, ...) eventHandle(self, event, ...) end)