local AceGUI = LibStub("AceGUI-3.0")
local addonName, BGS_FrameInfoTable = ...
local _frameName = "XPFrame"
local _detail = "BG Experience"
local _icon = [[Interface\ICONS\Spell_Holy_SurgeOfLight]]
local _info = "Experience gained in the current or last battleground"
local _options = {}

local scrollcontainer = AceGUI:Create("SimpleGroup") -- "InlineGroup" is also good
scrollcontainer:SetFullWidth(true)
scrollcontainer:SetWidth(185)
scrollcontainer:SetFullHeight(true) -- probably?
scrollcontainer:SetHeight(170)
scrollcontainer:SetLayout("Fill") -- important!

table.insert(_options, scrollcontainer)

	local scroll = AceGUI:Create("ScrollFrame")
	scroll:SetLayout("Flow") -- probably?
	scrollcontainer:AddChild(scroll)

	local frameDetail = AceGUI:Create("SimpleGroup")
	frameDetail:SetFullWidth(true)
	frameDetail:SetHeight(35)
	frameDetail:SetLayout("Fill")
	frameDetail.bg = frameDetail.frame:CreateTexture("frameDetail_Tex")
	frameDetail.bg:SetTexture("Interface\\LFGFRAME\\UI-LFG-SEPARATOR")
	frameDetail.bg:SetHeight(frameDetail.frame:GetHeight()/2)
	frameDetail.bg:SetTexCoord(0, 168/256, 0, 34/128)
	frameDetail.bg:SetPoint("bottom", 0, -2)
	frameDetail.text = frameDetail.frame:CreateFontString(nil, nil, "GameFontHighlightSmall")
	frameDetail.text:SetHeight(frameDetail.frame:GetHeight())
	frameDetail.text:SetText(_info)
	frameDetail.text:SetPoint("topleft", 0, 0)
	frameDetail.text:SetPoint("topright", 0, 0)
	scroll:AddChild(frameDetail)


table.insert(BGS_FrameInfoTable, { name = _frameName		--9
	, detail = _detail
	, icon = _icon
	, info = _info
	, options = _options
	}
	)
	
local function eventHandle(self, event, addon)
	local frame = BGS_FrameInfoTable:GetFrameByName(_frameName)
	if not (frame) then
		return
	end
	local isInstance, instanceType = IsInInstance()
	if event == "PLAYER_ENTERING_BATTLEGROUND" and instanceType == "pvp" then
		frame.text:SetText("0")
	return
	end
	if event == "CHAT_MSG_COMBAT_XP_GAIN" and instanceType == "pvp" then
		local gained = tonumber(string.match(addon, '%d+'))
		local frame = BGS_FrameInfoTable:GetFrameByName("XPFrame")
		local current = tonumber(frame.text:GetText())
		if current == nil then
			current = 0
		end
		frame.text:SetText(current + gained)
	end
	
	if event == "ADDON_LOADED" then
		if addon ~= addonName then return end
		self:UnregisterEvent("ADDON_LOADED")
		
		--createOptions()
		frame.text:SetText("0")
		return
		
	end
end

local _eventsFrame = CreateFrame("FRAME", "BGS_".._frameName.."Events");
_eventsFrame:RegisterEvent("CHAT_MSG_COMBAT_XP_GAIN");
_eventsFrame:RegisterEvent("PLAYER_ENTERING_BATTLEGROUND");
_eventsFrame:RegisterEvent("ADDON_LOADED");
_eventsFrame:SetScript("OnEvent", function(self, event, ...) eventHandle(self, event, ...) end)